/*
 *   JavaLightServer 0.3.0
 *   Copyright (C) 2007  hawake - hawake[at]gmail[dot]it
 *
 *   This program is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>
*/

import java.io.*;
import java.io.File.*;
import java.net.*;

public class JavaLightServer {
	public static void main(String[] args) {
		
		try {
			File settings = new File("settings.conf");
			String HostName = "";
			String WelcomeMessage = "";
			int NumPorta = 0;
			if (args.length != 0) {
				for (int i = 0 ; i < args.length; i++) {
					if (args[i].equals("-listen")) {
						try {
							if (settings.exists()) {
								int righe[] = {1, 2, 3};
								String conf[] = leggi("settings.conf", righe);
								NumPorta = Integer.parseInt(conf[0]);
								HostName = conf[1];
								WelcomeMessage = conf[2];
							}
							else {
								System.out.println("Settings file not found, first run the program with -setup attribute!");
								System.exit(0);
							}
							DataBank db = new DataBank();
							ServerSocket s = new ServerSocket(NumPorta);
							InetAddress inetAdd = s.getInetAddress();
							String a = inetAdd.getCanonicalHostName();
							inetAdd = null;
							while (true) {
								System.out.println("\nOpening the connection . . . ");
								Socket incoming = s.accept();
								System.out.println("Si  connesso: " + a + " Spawning " + i);
								db.WriteLog("Connected: " + a + " Spawning " + i);
								Runnable r = new ThreadedAnswer(incoming, i, HostName, WelcomeMessage, a);
								Thread t = new Thread(r);
								t.start();
								i++;
							}
						} catch (IOException e) {
							e.printStackTrace();
						} catch (NumberFormatException e) {
							System.out.println("Error " + e + " in input: number format wrong!");
							System.exit(0);
							return;
						}
					}
					if (args[i].equals("-help")) {
						help();
					}
					if (args[i].equals("-version")) {
						System.out.println("JavaLightServer Alpha 0.3.0 (only)Console Version.\n This software is an experimental one,\nit has more bugs and errors,\nDON'T use it for work!\nIt's released under the terms of the GNU General Public License version 3.\n");
					}
					if (args[i].equals("-setup")) {
						try {
							PrintStream Output = new PrintStream(new FileOutputStream("settings.conf"));
							PrintStream CreaLog = new PrintStream(new FileOutputStream("jls.log"));
							String tmpHostName;
							System.out.println("WARNING: The previous settings will be come overwrited!");
							System.out.print("Type the port where you want that the server listen: ");
							NumPorta = inputInt();
							System.out.print("Type a symbolic name for your host: ");
							HostName = inputStr();
							System.out.print("Type a welcome message: ");
							WelcomeMessage = inputStr();
							Output.println(NumPorta);
							Output.println(HostName);
							Output.println(WelcomeMessage);
							CreaLog.println("+-----------------------------------------------------------------------+");
							CreaLog.println("|                         JAVALIGHTSERVER's LOG                         |");
							CreaLog.println("+-----------------------------------------------------------------------+");
							CreaLog.println("");
							System.out.println("Creating log file . . . . . OK!");
							System.out.println("Setup ended! Now you can run 'JavaLightServer -listen' command.");
						} catch (NumberFormatException e) {
							System.out.println("Error " + e + " in input: number format wrong!");
							System.exit(0);
							return;
						}
					}
					if (args[i].equals("-printsetup")) {
						try {
							if (settings.exists()) {
								int righe[] = {1, 2, 3};
								String conf[] = leggi("settings.conf", righe);
								NumPorta = Integer.parseInt(conf[0]);
								HostName = conf[1];
								WelcomeMessage = conf[2];
								System.out.println("SETUP PRINTER - Actual configuration: ");
								System.out.println("HostName: " + HostName);
								System.out.println("Port: " + NumPorta);
								System.out.println("Welcome Message: " + WelcomeMessage + "\n");
							} else {
								System.out.println("Settings file not found, first run the program with -setup attribute!");
								System.exit(0);
							}
						} catch (NumberFormatException e) {
							System.out.println("Error " + e + " in input: number format wrong!");
							System.exit(0);
							return;
						}
					}
				}
			}
			else {
				help();
			}
		} catch (Exception e) {
			System.out.println("Error: " + e);
			return;
		}
	}
	static String [] leggi(String file, int [] righe) {
		String ret[] = new String[righe.length];
		try {
			BufferedReader in = new BufferedReader(new FileReader(file));
			int j = 0;
			for (int i = 1; i <= righe[righe.length-1]; i++) {
				if ( i == righe[j] ) ret[j++] = in.readLine();
				else in.readLine();
			}
			in.close();
		} catch (Exception e) {
			System.out.println(e);
		}
		return ret;
	}
	
	static String inputStr() {
		try {
			BufferedReader flussoInput = new BufferedReader(new InputStreamReader(System.in));
			String stringa = flussoInput.readLine();
			return stringa;
		} catch (IOException e) {
			System.out.println("Error: " + e + " in input");
			System.exit(0);
			return "";
		}
	}
	
	static int inputInt() {
		try {
			BufferedReader flussoInput = new BufferedReader(new InputStreamReader(System.in));
			String stringa = flussoInput.readLine();
			return (Integer.valueOf(stringa).intValue());
		} catch (Exception e) {
			System.out.println("Error: " + e + " in input");
			System.exit(0);
			return -1;
		}
	}
	static void help() {
		System.out.println("\n-version    | Print the version;");
		System.out.println("-listen     | Puts the server in listen on the setup port;");
		System.out.println("-help       | Print this help;");
		System.out.println("-setup      | Wizard to set up the server;");
		System.out.println("-printsetup | Print the actual configuration of the server;\n");
		System.out.println("[****] Software released under the terms of GNU General Public License version 3 [****]"); 
	}
}
