/*
 *  JavaLightServer 0.3.0
 *   Copyright (C) 2007  hawake - hawake[at]gmail[dot]it
 *
 *   This program is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>
*/

import java.io.*;
import java.net.*;
import java.net.NetworkInterface;
import java.util.*;

public class ThreadedAnswer implements Runnable {
	private Socket incoming;
	private int counter;
	private String HostName;
	private String WelcomeMessage;
	private String IpRemoto;
	private DataBank db = new DataBank();
	
	/**
	   @param i il socket in entrata
	   @param c il contatore(compare nella parte server)
	   @param h hostname simbolico del server
	   @param w il messaggio di benvenuto
	   @param p l'IP connesso
	*/
	
	public ThreadedAnswer(Socket i, int c, String h, String w, String ip) {
		incoming = i;
		counter = c;
		HostName = h;
		WelcomeMessage = w;
		IpRemoto = ip;
	}
	public void run() {
		try {
			try {
				InputStream inStream = incoming.getInputStream();
				OutputStream outStream = incoming.getOutputStream();
				Scanner in = new Scanner(inStream);
				PrintWriter out = new PrintWriter(outStream, true /* autoFlush */);
				if (WelcomeMessage.equals("")) {
					out.println("Welcome to " + HostName + " (OS: " +
						System.getProperty("os.name") + " " +
						System.getProperty("os.version") + " User: " +
						System.getProperty("user.name") + ")\n");
				} else {
					out.println(WelcomeMessage);
				}
				boolean done = false;
				while (!done && in.hasNextLine()) {
					String line = in.nextLine();
					String appoggio = line.trim();
					String comando = (line.trim()).toUpperCase();
					if (comando.equals("QUIT")) {
						out.println("Goodbye Sir!");
						done = true;
						System.out.println("An user escaped from server.");
						db.WriteLog(IpRemoto + " escaped from server.");
					} else if (comando.equals("HELO")) {
						db.WriteLog(IpRemoto + " used HELO!");
						out.println("Welcome to " + HostName + " (OS: " +
							System.getProperty("os.name") + " " +
							System.getProperty("os.version") + " User: " +
							System.getProperty("user.name") + ")\n");
						out.println("Have a lot fun!");
						out.println("Hawake");
					} else if (comando.equals("HELP")) {
						out.println("225 Echo: " + comando);
						out.println("[*] List of command supported in this version [*]\n");
						out.println("QUIT           | Escape from Server;");
						out.println("HELO           | Greetings to Server;");
						out.println("HELP           | Print this help;");
						out.println("PASSWD         | Secure password creator;");
						out.println("PWD            | Get the current server directory");
						out.println("LS -parameter  | List of file in the current server directory");
						out.println("MKDIR dir      | Make a new directory in the absolute path of the server;");
						out.println("GET -parameter | Print information about the server's system;");
						out.println("VI file        | Make a new file with a common content;");
						out.println("CAT file       | See a file content;");
						out.println("DEL file       | Delete a custom file from server;");
						out.println("\n App. Maintener: hawake");
						out.println("Developers: EgiX, hawake");
						out.println("Founder's e-mail: hawake@gmail.com");
						out.println("Server Version: 0.3.0");
						out.println("License: GNU GPL v3;");
						out.println("Hosted by SourceForge.net");
						out.println("Also Powered by the NetProg.it OpenSource Community\n");
						db.WriteLog(IpRemoto + " Used HELP!");
					} else if (comando.equals("PWD")) {
						out.println("Current server directory: " + System.getProperty("user.dir") + "\n");
						db.WriteLog(IpRemoto + " Used PWD");
					} else if (comando.equals("LS")) {
						String Parameter = (line.length()>=3) ? line.substring(3) : "";
						if (Parameter.length()==0) {
							File f = new File(System.getProperty("user.dir"));
							if (f.isDirectory())  {
								out.println("Opening remote directory " + f.getAbsolutePath() + " . . . . .");
								String[] content = f.list();
								out.println("Content of the directory:\n");
								for (int i=0; i<content.length; i++)
									out.println(content[i]);
							} else if (!f.isDirectory()) {
								out.println(f + " isn't a directory!");
							}
						} else if (Parameter.equals("-l")) {
							out.println("Under work!");
							db.WriteLog(IpRemoto + " Used LS -l");
							// VEDI PIU' IN BASSO //
							/*File f = new File(System.getProperty("user.dir"));
							if (f.isDirectory())  {
								out.println("Opening remote directory " + f.getAbsolutePath() + " . . . . .");
								String[] content = f.list();
								out.println("Content of the directory:\n");
								for (int i = 0; i < content.length; i++)
									if (content[i].isDirectory()) {
										out.println(content[i] + " DIRECTORY");
									}
							} else if (!f.isDirectory()) {
								out.println(f + " isn't a directory!");
							}*/
						} else if (Parameter.equals("-h")) {
							out.println("Under work!");
							db.WriteLog(IpRemoto + " Used LS -h");
							/*
							 * Per implementare questa funzione l'array
							 * dei file deve essere trasformata da String
							 * a File, cos si possono applicare tutti
							 * i metodi facilmente.
							*/
						}
						db.WriteLog(IpRemoto + " Used LS");
					} else if (comando.startsWith("MKDIR")) {
						File f = null;
						String dir = (line.length()>=6) ? line.substring(6) : "";
						String cwd = System.getProperty("user.dir");
						if (dir.length()==0) out.println("Invalid directory name!\n");
						else {
							if (dir.startsWith(cwd.substring(0,3))) f = new File(dir);
							else f = new File(System.getProperty("user.dir") + File.separator + dir);
							if (f.exists()) out.println("Invalid directory name!\n");
							else {
								f.mkdir();
								out.println("Creating directory " + f.getPath() + " . . . OK!\n");
							}
						}
					} else if (comando.startsWith("GET")) {
						Properties env = System.getProperties();
						Enumeration keys = env.keys();
						String Parameter = (line.length()>=4) ? line.substring(4) : "";
						if (Parameter.length()==0) {
							out.println("Type -help parameter for more information!\n");
						} else if (Parameter.equals("-help")) {
							out.println("** GET Command - HELP **");
							out.println("-help | Print this help;");
							out.println("-all  | Print all information avaiable about the Server's System;");
							out.println("-os   | Print information about the Operating System of the Server's System;");
							out.println("-user | Print all information about the user who run the Server;");
							out.println("-path | Print the systems' variables;");
							out.println("-ni   | Print the Network Interface of the server;");
							db.WriteLog(IpRemoto + " used GET -help");
						} else if (Parameter.equals("-all")) {
							while(keys.hasMoreElements()) {
								String key = (String)keys.nextElement();
								String value = env.getProperty(key);
								out.println(String.format("%s = %s", key, value));
							}
							db.WriteLog("Used GEt -all");
						} else if (Parameter.equals("-os")) {
							out.println(String.format("Operating System: %s", System.getProperty("os.name")));
							out.println(String.format("Version: %s", System.getProperty("os.version")));
							out.println(String.format("Java Version: %s", System.getProperty("java.version")));
							db.WriteLog("Used GET -os");
						} else if (Parameter.equals("-user")) {
							while(keys.hasMoreElements()) {
								String key = (String)keys.nextElement();
								if (key.startsWith("user.")) {
									String value = env.getProperty(key);
									out.println(String.format("%s = %s", key, value));
								}
							}
							db.WriteLog("Used GET -user");
						} else if (Parameter.equals("-path")) {
							Map<String, String>env2 = System.getenv();
							Iterator<String>keys2 = env2.keySet().iterator();
							
							while(keys2.hasNext()) {
								String key = keys2.next();
								String value = env2.get(key);
								out.println(String.format("%s = %s", key, value));
							}
							db.WriteLog("Used GET -path");
						} else if (Parameter.equals("-ni")) {
							try {
								Enumeration<NetworkInterface> nis = NetworkInterface.getNetworkInterfaces();
								while(nis.hasMoreElements()) {
									NetworkInterface ni = nis.nextElement();
									
									out.println(ni.getDisplayName());
									out.println("IP Addresses: ");
									Enumeration<InetAddress> addresses = ni.getInetAddresses();
									while(addresses.hasMoreElements()) {
										InetAddress address = addresses.nextElement();
										out.println(address.getHostAddress());
									}
								}
							} catch (SocketException e) {
								e.printStackTrace();
							}
							db.WriteLog("Used GET -ni");
						}
						db.WriteLog("Used GET");
					} else if (comando.startsWith("VI")) {
						// DA SOSTITUIRE CON VI
						out.println("Comand under work yet!");
						System.out.println("Used the comand VI, under work yet!");
						/*////////////////////////////////////////*
						String[] tmp = comando.split(" ");
						String FileContent = tmp[2];
						FileContent = (line.length()>=7) ? line.substring(7) : "";
						FileOutputStream MakedFile = new FileOutputStream(tmp[1]);
						PrintStream Output = new PrintStream(MakedFile);
						Output.println(tmp[2]);
						out.println("Creating file . . . OK!\n");
						*//////////////////////////////////////////
					} else if (comando.startsWith("DEL")) {
						File f = null;
						String FileName = (line.length()>=4) ? line.substring(4) : "";
						String cwd = System.getProperty("user.dir");
						if (FileName.length()==0) out.println("Invalid file name!\n");
						else {
							if (FileName.startsWith(cwd.substring(0,3))) f = new File(FileName);
							else f = new File(System.getProperty("user.dir") + File.separator + FileName);
							if (!f.exists()) out.println(FileName + " not exists!\n");
							else {
								f.delete();
								out.println("Deleting " + f.getPath() + " . . . OK!\n");
							}
						}
						System.out.println("E' stato usato il comando DEL");
					} else if (comando.startsWith("CWD"))   {
						File f = null;
						String dir = (line.length()>=4) ? line.substring(4) : "";
						String cwd = System.getProperty("user.dir");
						if (dir.length()==0) out.println("Invalid directory name!\n");
						else {
							if (dir.equals(".")) { // vai alla root
								String root = System.getProperty("user.dir");
								f = new File(root.substring(0, root.indexOf(File.separator)+1));
							} else if (dir.equals("..")) { // vai alla directory sovrastante
								f = new File(cwd.substring(0, cwd.lastIndexOf(File.separator)+1));
							} else {
								if (dir.startsWith(cwd.substring(0,3))) f = new File(dir);
								else f = new File(System.getProperty("user.dir") + File.separator + dir);
							}
						}
						if (f.isDirectory()) {
							System.setProperty("user.dir", f.getPath());
							out.println("Remote directory changed to " + f.getPath() + "\n");
						} else {
							out.println(dir + " isn't a valid directory path!\n");
						}
					} else if (comando.startsWith("PASSWD")) {
						String array="abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890";
						String[] tmp = comando.split(" ");
						int tmpInt = Integer.parseInt(tmp[1]);
						int n = tmpInt;
						out.println("[****] JAVALIGHTSERVER SECURE PASSWORD CREATOR [****]");
						out.println("Generating password . . . OK!\n");
						String[] parola = new String[tmpInt];
						for(int i=0; i<n; i++) {
							int a=(int)(Math.random()*55+tmpInt);
							parola[i] = array.substring(a, a+1);
						}
						for(int i=0; i<n; i++)
							out.println(parola[i]);
					} else {
						out.println("ERROR! Type help for more information!");
					}
				}
			} finally {
				incoming.close();
				while (!Thread.currentThread().isInterrupted()) { }
			}
		} catch (IOException e) {
			System.out.println("Error in Input/Output: ");
			e.printStackTrace();
		}
	}
}
